/* Definitions of target machine for GNU compiler,
   for MIPS Linux-based GNU systems.
   Copyright (C) 1998 Free Software Foundation, Inc.
   Contributed by by Ralf Baechle (ralf@gnu.org)

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#undef TARGET_DEFAULT
#define TARGET_DEFAULT (MASK_ABICALLS|MASK_GAS)

#undef MACHINE_TYPE
#if TARGET_ENDIAN_DEFAULT == 0
#define MACHINE_TYPE "(MIPSEL Linux/ELF)"
#else
#define MACHINE_TYPE "(MIPS Linux/ELF)"
#endif

#undef CPP_PREDEFINES
#if TARGET_ENDIAN_DEFAULT == 0
#define CPP_PREDEFINES "\
-D__ELF__ -D_MIPS_SIM=_MIPS_SIM_ABI32 \
-D__PIC__ -D__pic__ -Dunix -Dmips -DR3000 -DMIPSEL -Dlinux \
-Asystem(linux) -Asystem(posix) -Acpu(mips) -Amachine(mips)"
#else
#define CPP_PREDEFINES "\
-D__ELF__ -D_MIPS_SIM=_MIPS_SIM_ABI32 \
-D__PIC__ -D__pic__ -Dunix -Dmips -DR3000 -DMIPSEB -Dlinux \
-Asystem(linux) -Asystem(posix) -Acpu(mips) -Amachine(mips)"
#endif

#undef SUBTARGET_CPP_SPEC
#define SUBTARGET_CPP_SPEC "\
%{fno-PIC:-U__PIC__ -U__pic__} %{fno-pic:-U__PIC__ -U__pic__} \
%{fPIC:-D__PIC__ -D__pic__} %{fpic:-D__PIC__ -D__pic__} \
%{-D__HAVE_FPU__} \
%{posix:-D_POSIX_SOURCE}"

#undef SUBTARGET_ASM_SPEC
#define SUBTARGET_ASM_SPEC "\
%{!fno-PIC:%{!fno-pic:-KPIC}} %{fPIC:-KPIC} %{fpic:-KPIC} \
%{fno-PIC:-non_shared} %{fno-pic:-non_shared} \
%{membedded-pic}"

#undef LINK_SPEC
#if TARGET_ENDIAN_DEFAULT == 0
#define LINK_SPEC "-m elf32lsmip \
%{G*} %{EB} %{EL} %{mips1} %{mips2} %{mips3} %{mips4} \
%{bestGnum} %{shared} %{non_shared} \
%{call_shared} %{no_archive} %{exact_version} \
  %{!shared: \
      %{!static: \
       %{rdynamic:-export-dynamic} \
       %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
       %{static:-static}}"
#else
#define LINK_SPEC "-m elf32bsmip \
%{G*} %{EB} %{EL} %{mips1} %{mips2} %{mips3} %{mips4} \
%{bestGnum} %{shared} %{non_shared} \
%{call_shared} %{no_archive} %{exact_version} \
  %{!shared: \
      %{!static: \
       %{rdynamic:-export-dynamic} \
       %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
       %{static:-static}}"
#endif

#undef STARTFILE_SPEC
#define STARTFILE_SPEC \
"%{!shared:%{pg:gcrt1.o%s}%{!pg:%{p:gcrt1.o%s}\
   %{!p:%{profile:gcrt1.o%s}%{!profile:crt1.o%s}}}} \
crti.o%s %{!shared:crtbegin.o%s} %{shared:crtbeginS.o%s}"

#undef ENDFILE_SPEC
#define ENDFILE_SPEC \
"%{!shared:crtend.o%s} %{shared:crtendS.o%s} crtn.o%s"


/*
 * We don't need no stinkin' coff.
 */
#undef OBJECT_FORMAT_COFF

/*
 * -G is incompatible with -KPIC which is the default, so only allow objects
 * in the small data section if the user explicitly asks for it.
 */
#undef MIPS_DEFAULT_GVALUE
#define MIPS_DEFAULT_GVALUE 0

/*
 * Since gas and gld are standard on Linux, we don't need these
 */
#undef MD_EXEC_PREFIX
#undef MD_STARTFILE_PREFIX
#undef ASM_FINAL_SPEC

/*
 * No need for these since gcc is the only c/c++/objc compiler for Linux/MIPS
 */
#undef PCC_BITFIELD_TYPE_MATTERS
#define PCC_BITFIELD_TYPE_MATTERS 1
#undef PCC_STATIC_STRUCT_RETURN

/* Don't assume anything about the header files. */
#define NO_IMPLICIT_EXTERN_C

#undef HAVE_ATEXIT
#define HAVE_ATEXIT

/* Generate calls to memcpy, etc., not bcopy, etc. */
#define TARGET_MEM_FUNCTIONS

/* Specify wchar_t types.  */
#undef  WCHAR_TYPE
#undef  WCHAR_TYPE_SIZE
#undef  MAX_WCHAR_TYPE_SIZE

#define WCHAR_TYPE      "long int"
#define WCHAR_TYPE_SIZE LONG_TYPE_SIZE
#define MAX_WCHAR_TYPE_SIZE     MAX_LONG_TYPE_SIZE
